"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncLocalStorageInterceptor = void 0;
const common_1 = require("@nestjs/common");
const rxjs_1 = require("rxjs");
const async_local_storage_constants_1 = require("./async-local-storage.constants");
const async_local_storage_interfaces_1 = require("./async-local-storage.interfaces");
const async_local_storage_service_1 = require("./async-local-storage.service");
let AsyncLocalStorageInterceptor = class AsyncLocalStorageInterceptor {
    constructor(asyncLocalStorage, options) {
        this.asyncLocalStorage = asyncLocalStorage;
        this.options = options;
        const { useGuard, useInterceptor } = this.options;
        this.mode = useGuard ? async_local_storage_interfaces_1.AsyncLocalStorageMode.Guard : useInterceptor ? async_local_storage_interfaces_1.AsyncLocalStorageMode.Interceptor : null;
    }
    async intercept(context, next) {
        if (this.mode === async_local_storage_interfaces_1.AsyncLocalStorageMode.Guard) {
            const response = await (0, rxjs_1.lastValueFrom)(next.handle());
            this.asyncLocalStorage.exit();
            return (0, rxjs_1.of)(response);
        }
        const response = await this.asyncLocalStorage.instance.run(new Map(), () => {
            this.asyncLocalStorage.requestContext = this.options.requestContextFactory(context);
            return (0, rxjs_1.lastValueFrom)(next.handle());
        });
        return (0, rxjs_1.of)(response);
    }
};
AsyncLocalStorageInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(async_local_storage_service_1.AsyncLocalStorageService)),
    __param(1, (0, common_1.Inject)(async_local_storage_constants_1.ASYNC_LOCAL_STORAGE_MODULE_OPTIONS)),
    __metadata("design:paramtypes", [async_local_storage_service_1.AsyncLocalStorageService, Object])
], AsyncLocalStorageInterceptor);
exports.AsyncLocalStorageInterceptor = AsyncLocalStorageInterceptor;
//# sourceMappingURL=async-local-storage.interceptor.js.map