"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var AsyncLocalStorageModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncLocalStorageModule = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const async_local_storage_guard_1 = require("./async-local-storage.guard");
const async_local_storage_interceptor_1 = require("./async-local-storage.interceptor");
const async_local_storage_providers_1 = require("./async-local-storage.providers");
let AsyncLocalStorageModule = AsyncLocalStorageModule_1 = class AsyncLocalStorageModule {
    static forRoot(options) {
        const { isGlobal, useGuard, useInterceptor } = options;
        if (!options.requestContextFactory) {
            throw new Error('`requestContextFactory` is required.');
        }
        if (useGuard && useInterceptor) {
            throw new Error("Can't use both guard and interceptor.");
        }
        const providers = (0, async_local_storage_providers_1.createAsyncLocalStorageProviders)(options);
        return {
            global: isGlobal,
            module: AsyncLocalStorageModule_1,
            providers: [
                ...providers,
                ...(useGuard
                    ? [
                        {
                            provide: core_1.APP_GUARD,
                            useClass: async_local_storage_guard_1.AsyncLocalStorageGuard,
                        },
                        {
                            provide: core_1.APP_INTERCEPTOR,
                            useClass: async_local_storage_interceptor_1.AsyncLocalStorageInterceptor,
                        },
                    ]
                    : []),
                ...(useInterceptor
                    ? [
                        {
                            provide: core_1.APP_INTERCEPTOR,
                            useClass: async_local_storage_interceptor_1.AsyncLocalStorageInterceptor,
                        },
                    ]
                    : []),
            ],
            exports: providers,
        };
    }
};
AsyncLocalStorageModule = AsyncLocalStorageModule_1 = __decorate([
    (0, common_1.Module)({})
], AsyncLocalStorageModule);
exports.AsyncLocalStorageModule = AsyncLocalStorageModule;
//# sourceMappingURL=async-local-storage.module.js.map