"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAsyncLocalStorageProviders = void 0;
const async_hooks_1 = require("async_hooks");
const async_local_storage_constants_1 = require("./async-local-storage.constants");
const async_local_storage_service_1 = require("./async-local-storage.service");
const defaultAsyncLocalStorage = (isGlobal) => isGlobal ? globalThis.__asyncLocalStorage || new async_hooks_1.AsyncLocalStorage() : new async_hooks_1.AsyncLocalStorage();
function createAsyncLocalStorageProviders(options) {
    const { asyncLocalStorage = defaultAsyncLocalStorage(options.isGlobal) } = options;
    const opts = { ...options, asyncLocalStorage };
    return [
        { provide: async_local_storage_constants_1.ASYNC_LOCAL_STORAGE, useValue: asyncLocalStorage },
        {
            provide: async_local_storage_constants_1.ASYNC_LOCAL_STORAGE_MODULE_OPTIONS,
            useValue: opts,
        },
        {
            provide: async_local_storage_service_1.AsyncLocalStorageService,
            inject: [async_local_storage_constants_1.ASYNC_LOCAL_STORAGE],
            useFactory(store) {
                return new async_local_storage_service_1.AsyncLocalStorageService(store);
            },
        },
    ];
}
exports.createAsyncLocalStorageProviders = createAsyncLocalStorageProviders;
//# sourceMappingURL=async-local-storage.providers.js.map