"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var AsyncLocalStorageService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncLocalStorageService = void 0;
const common_1 = require("@nestjs/common");
const async_hooks_1 = require("async_hooks");
const async_local_storage_constants_1 = require("./async-local-storage.constants");
let AsyncLocalStorageService = AsyncLocalStorageService_1 = class AsyncLocalStorageService extends Map {
    constructor(instance) {
        super();
        AsyncLocalStorageService_1.instance ??= instance;
        this.instance = AsyncLocalStorageService_1.instance || instance;
    }
    static get instance() {
        return this._instance || globalThis.__asyncstorage;
    }
    static set instance(value) {
        this._instance = value;
    }
    static get store() {
        return this.instance?.getStore();
    }
    static get requestContext() {
        return this.store?.get(async_local_storage_constants_1.REQUEST_CONTEXT_KEY);
    }
    static set requestContext(value) {
        this.store?.set(async_local_storage_constants_1.REQUEST_CONTEXT_KEY, value);
    }
    static enterWith(value = new Map()) {
        this.instance?.enterWith(value);
    }
    static enter() {
        this.enterWith();
    }
    static exit(cb = async_local_storage_constants_1.noOp) {
        this.instance?.exit(cb);
    }
    run(store = new Map(), callback, ...args) {
        return this.instance.run(store, callback, ...args);
    }
    enterWith(value = new Map()) {
        this.instance.enterWith(value);
    }
    enter() {
        this.enterWith();
    }
    exit(cb = async_local_storage_constants_1.noOp) {
        this.instance.exit(cb);
    }
    get store() {
        return this.instance.getStore();
    }
    isStoreInitialized() {
        return !!this.store;
    }
    checkStoreInitialized() {
        if (!this.isStoreInitialized()) {
            throw new Error("Store is not initialized. Call 'enterWith' or 'run' first.");
        }
    }
    get safeStore() {
        this.checkStoreInitialized();
        return this.store;
    }
    get(key) {
        return this.safeStore.get(key);
    }
    set(key, value) {
        this.safeStore.set(key, value);
        return this;
    }
    delete(key) {
        return this.safeStore.delete(key);
    }
    has(key) {
        return this.safeStore.has(key);
    }
    clear() {
        return this.safeStore.clear();
    }
    get size() {
        return this.safeStore.size;
    }
    get [Symbol.toStringTag]() {
        return this.safeStore[Symbol.toStringTag];
    }
    keys() {
        return this.safeStore.keys();
    }
    values() {
        return this.safeStore.values();
    }
    entries() {
        return this.safeStore.entries();
    }
    forEach(callbackfn, thisArg) {
        return this.safeStore.forEach(callbackfn, thisArg);
    }
    [Symbol.iterator]() {
        return this.safeStore[Symbol.iterator]();
    }
    get requestContext() {
        return this.get(async_local_storage_constants_1.REQUEST_CONTEXT_KEY);
    }
    set requestContext(value) {
        this.set(async_local_storage_constants_1.REQUEST_CONTEXT_KEY, value);
    }
};
AsyncLocalStorageService = AsyncLocalStorageService_1 = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(async_local_storage_constants_1.ASYNC_LOCAL_STORAGE)),
    __metadata("design:paramtypes", [async_hooks_1.AsyncLocalStorage])
], AsyncLocalStorageService);
exports.AsyncLocalStorageService = AsyncLocalStorageService;
//# sourceMappingURL=async-local-storage.service.js.map